use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd 0x0
  dd cur_path

include 'macros.inc'
include 'vector.inc'

sam:
  .x dd 180.0
  .y dd 100.0
  .a dd 0.0 ;angle
  .s dd 1.0 ;scale

sam_prop:
  .da dd 0.15708
cont:
  dw 21
  dd -2.0,-12.0, -2.0,-10.0, -4.0,-9.5, -4.0,-8.5, -2.0,-7.0, -2.0,-6.0, -7.0,-5.0, -7.0,-3.0, -2.0,1.0, -2.0,3.0
  dd 0.0,5.0, 2.0,3.0, 2.0,1.0, 7.0,-3.0, 7.0,-5.0, 2.0,-6.0, 2.0,-7.0, 4.0,-8.5, 4.0,-9.5, 2.0,-10.0, 2.0,-12.0
  dw 2
  dd 0.0,5.0, 0.0,8.5
  dw 2
  dd -2.0,-10.0, 2.0,-10.0
  dw 0


align 4
start:
  mov ecx,sc
  mov edx,sizeof.system_colors
  mcall 48,3
  mcall 40,0x27
  mov eax,cont
  call convert_contur


red_win:
  call draw_window

still:
  mcall 10

  cmp al,0x1 ;.  
  jz red_win
  cmp al,0x2
  jz key
  cmp al,0x3
  jz button
  jmp still

draw_window:
  push eax ebx ecx edx
  mcall 12,1

  xor eax,eax
  mov ebx,50*65536+320
  mov ecx,30*65536+250
  mov edx,[sc.work]
  or  edx,0x33000000
  mov edi,hed
  mcall


  mov edx,0xff
  mov eax,sam
  mov ebx,cont
  call draw_vector

  mcall 12,2
  pop edx ecx ebx eax
  ret

Sam_RotLeft:
  fld dword[sam.a]
  fsub dword[sam_prop.da]
  fstp dword[sam.a]
  ret

Sam_RotRight:
  fld dword[sam.a]
  fadd dword[sam_prop.da]
  fstp dword[sam.a]
  ret


key:
  mcall 2

  cmp ah,176 ;Left
  jne @f
    call Sam_RotLeft
    call draw_window
  @@:
  cmp ah,179 ;Right
  jne @f
    call Sam_RotRight
    call draw_window
  @@:

  jmp still

button:
;  mcall 17 ;   
;  cmp ah,1
;  jne still
.exit:
  mcall -1 ;  


hed db 'Test',0
sc system_colors 

i_end: ; 
  rb 1024
stacktop:
  cur_path:
    rb 4096
mem:

