use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd 0x0
  dd cur_path

include 'macros.inc'
include 'vector.inc'

arr0c:
  .x dd 0.0
  .y dd 0.0
  .a dd 0.0 ;angle
  .s dd 1.0 ;scale
arr0v:
  dw 4
  dd 7.0,0.0, 0.0,-3.0, 0.0,3.0, 7.0,0.0
  dw 0

align 4
start:
  mov ecx,sc
  mov edx,sizeof.system_colors
  mcall 48,3
  mcall 40,0x25
  mov eax,arr0v
  call convert_contur



red_win:
  mcall 12,1

  xor eax,eax
  mov ebx,50*65536+320
  mov ecx,30*65536+250
  mov edx,0xffffff;[sc.work]
  or  edx,0x33000000
  mov edi,hed
  mcall


  mov edx,0xff
  mov eax,30*65536+70
  mov ebx,200*65536+170
  call draw_arrow

  mov edx,0xff00
  mov eax,180*65536+10
  mov ebx,130*65536+110
  call draw_arrow

  mov edx,0xff0000
  mov eax,230*65536+180
  mov ebx,100*65536+180
  call draw_arrow

  mcall 12,2

still:
  mcall 10

  cmp al,0x1 ;.  
  jz red_win
  cmp al,0x3
  jz button
  jmp still

;input:
; eax = x0,y0
; ebx = x1,y1
; edx = color
draw_arrow:
  push ecx
    mov ecx,ebx
    sub cx,ax
    ror ecx,16
    ror eax,16
    sub cx,ax
    ;ror ecx,16
    ror eax,16
    push dword ecx
    call opred2i
    finit
    fld dword [o_ang]
    fstp dword [arr0c.a]
  pop ecx
;---------------------------------------------
;  push eax ebx
;    mov dword[o_dan],eax

;    fild word [o_dan]
;    fstp dword [arr0c.y]
;    fild word [o_dan+2]
;    fstp dword [arr0c.x]

    ;mov edx,0xff
;    mov eax,arr0c
;    mov ebx,arr0v
;    call draw_vector
;  pop ebx eax
;---------------------------------------------
  push edx eax ebx
  call line_brs
;---------------------------------------------
  push eax ebx
    mov dword[o_dan],ebx

    fild word [o_dan]
    fstp dword [arr0c.y]
    fild word [o_dan+2]
    fstp dword [arr0c.x]

    ;mov edx,0xff
    mov eax,arr0c
    mov ebx,arr0v
    call draw_vector
  pop ebx eax
;---------------------------------------------
  ret


button:
;  mcall 17 ;   
;  cmp ah,1
;  jne still
.exit:
  mcall -1 ;  


o_dan dd ?
hed db 'Vectors',0
sc system_colors 

i_end: ; 
  rb 1024
stacktop:
  cur_path:
    rb 4096
mem:

