use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd 0x0
  dd cur_path

include 'macros.inc'
include 'vector.inc'

arr0c:
  .x dd 0.0
  .y dd 0.0
  .a dd 0.0 ;angle
  .s dd 1.0 ;scale
arr0v:
  dw 10
    dd 4.8,-5.6, 36.4,-5.6, 36.4,-18.8, 30.8,-24.4
    dd 26.4,-24.4, 20.0,-18.0, 16.0,-22.0, 9.2,-22.0
    dd 4.8,-17.6, 4.8,-5.6
  dw 7
    dd 8.8,-10.0, 15.2,-10.0, 15.2,-16.0
    dd 12.4,-18.8, 10.0,-18.8, 8.8,-16.8, 8.8,-10.0
  dw 7
    dd 23.6,-9.2, 32.4,-9.2, 32.4,-17.2
    dd 30.4,-19.2, 26.8,-19.2, 23.6,-15.6, 23.6,-9.2
  dw 0

align 4
start:
  mov ecx,sc
  mov edx,sizeof.system_colors
  mcall 48,3
  mcall 40,0x25
  mov eax,arr0v
  call convert_contur



red_win:
  mcall 12,1

  xor eax,eax
  mov ebx,50*65536+320
  mov ecx,30*65536+250
  mov edx,0xffffff;[sc.work]
  or  edx,0x33000000
  mov edi,hed
  mcall


  mov edx,0xff
  mov eax,30*65536+70
  mov ebx,0
  call draw_arrow

  mov edx,0xd000
  mov eax,180*65536+50
  mov ebx,30
  call draw_arrow

  mov edx,0xff0000
  mov eax,230*65536+180
  mov ebx,90
  call draw_arrow

  mcall 12,2

still:
  mcall 10

  cmp al,0x1 ;.  
  jz red_win
  cmp al,0x3
  jz button
  jmp still

;input:
; eax = x0,y0
; bx = angle
; edx = color
draw_arrow:
  mov dword [o_dan],eax
  mov word [o_ang],bx

  finit
  fild word [o_dan]
  fstp dword [arr0c.y]
  fild word [o_dan+2]
  fstp dword [arr0c.x]

  mov word [o_dan],180 ;pi=180
  fild word [o_dan]
  fldpi
  fild word [o_ang]
  fmul st0,st1
  fdiv st0,st2
  fstp dword [arr0c.a]
;---------------------------------------------
  push eax ebx
    ;mov edx,0xff
    mov eax,arr0c
    mov ebx,arr0v
    call draw_vector
  pop ebx eax
;---------------------------------------------
  ret


button:
;  mcall 17 ;   
;  cmp ah,1
;  jne still
.exit:
  mcall -1 ;  


o_dan dd ?
hed db 'Font in vector',0
sc system_colors 

i_end: ; 
  rb 1024
stacktop:
  cur_path:
    rb 4096
mem:

